<?php

namespace FiloBlu\Kpi\Model;

class Addkpidata extends Core
{
    public function addData(){
        $productCollection = $this->getProductsCollection();

        $productCollection->AddAttributeToSelect('parent_sku_kpi', 'left');
        $productCollection->AddAttributeToSelect('url_image_kpi', 'left');
        $productCollection->addAttributeToFilter('type_id', 'simple');

        $tot = $productCollection->getSize();
        $i = 0;

        foreach ($productCollection as $simple) {

            $i++;

            $parentIds = $this->_productConfigurable->getParentIdsByChild($simple->getId());

            if ($parentIds && is_array($parentIds) && count($parentIds) > 0) {
                $parentId = $parentIds[0];
            } else {
                $parentId = $simple->getId();
            }

            $parentProduct = $this->_productRepositoryInterface->getById($parentId);
            $parentSku = $parentProduct->getSku();

            $absolutePath = $this->_filesystem->getDirectoryRead(\Magento\Framework\App\Filesystem\DirectoryList::MEDIA)->getAbsolutePath();
            $absolutePath .= 'catalog/product' . $parentProduct->getImage();

            $absolutePathImageResized = strtolower(str_replace('catalog/product', 'catalog/product/bi', $absolutePath));

            if (file_exists($absolutePath) && $parentProduct->getImage() && $parentProduct->getImage() != '') {
                if (!file_exists($absolutePathImageResized)) {
                    $imageResize = $this->_adapterFactory->create();
                    $imageResize->open($absolutePath);
                    $imageResize->constrainOnly(TRUE);
                    $imageResize->keepAspectRatio(TRUE);
                    $imageResize->resize(200, 200);
                    $imageResize->save($absolutePathImageResized);
                }
                $resizedUrl = $this->_storeManagerInterface->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA) . 'catalog/product/bi' . strtolower($parentProduct->getImage());
            } else {
                $resizedUrl = null;
            }

            $this->_helper->writeLog("Product {$i} of {$tot}","filoblu_kpi.log");
            $this->_helper->writeLog("Product ID: {$simple->getId()}","filoblu_kpi.log");
            $this->_helper->writeLog("Product SKU: {$parentSku}","filoblu_kpi.log");
            $this->_helper->writeLog("Image URL {$resizedUrl}","filoblu_kpi.log");

            if ($simple->getParentSkuKpi() != $parentSku) {
                $this->_productAction->updateAttributes(
                    array($simple->getId()), array('parent_sku_kpi' => $parentSku), 0);
            }

            if ($simple->getUrlImageKpi() != $resizedUrl) {
                $this->_productAction->updateAttributes(
                    array($simple->getId()), array('url_image_kpi' => $resizedUrl), 0);
            }
        }

    }

}
